diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/wifi/test/wifi-emlsr-test.cc ns-3.40/src/wifi/test/wifi-emlsr-test.cc
--- ns-3.39/src/wifi/test/wifi-emlsr-test.cc	2023-07-05 14:23:48.129428400 -0700
+++ ns-3.40/src/wifi/test/wifi-emlsr-test.cc	2023-09-27 13:30:37.922839900 -0700
@@ -55,15 +55,6 @@
 
 NS_LOG_COMPONENT_DEFINE("WifiEmlsrTest");
 
-static uint32_t
-ContextToNodeId(std::string context)
-{
-    std::string sub = context.substr(10);
-    uint32_t pos = sub.find("/Device");
-    uint32_t nodeId = std::stoi(sub.substr(0, pos));
-    return nodeId;
-}
-
 /**
  * \ingroup wifi-test
  * \ingroup tests
@@ -92,7 +83,7 @@
 void
 EmlOperatingModeNotificationTest::DoRun()
 {
-    MgtEmlOperatingModeNotification frame;
+    MgtEmlOmn frame;
 
     // Both EMLSR Mode and EMLMR Mode subfields set to 0 (no link bitmap);
     TestHeaderSerialization(frame);
@@ -113,7 +104,7 @@
     auto transition = MicroSeconds(128);
 
     frame.m_emlControl.emlsrParamUpdateCtrl = 1;
-    frame.m_emlsrParamUpdate = MgtEmlOperatingModeNotification::EmlsrParamUpdate{};
+    frame.m_emlsrParamUpdate = MgtEmlOmn::EmlsrParamUpdate{};
     frame.m_emlsrParamUpdate->paddingDelay = CommonInfoBasicMle::EncodeEmlsrPaddingDelay(padding);
     frame.m_emlsrParamUpdate->transitionDelay =
         CommonInfoBasicMle::EncodeEmlsrTransitionDelay(transition);
@@ -168,14 +159,14 @@
     /**
      * Callback invoked when a FEM passes PSDUs to the PHY.
      *
-     * \param linkId the ID of the link transmitting the PSDUs
-     * \param context the context
+     * \param mac the MAC transmitting the PSDUs
+     * \param phyId the ID of the PHY transmitting the PSDUs
      * \param psduMap the PSDU map
      * \param txVector the TX vector
      * \param txPowerW the tx power in Watts
      */
-    virtual void Transmit(uint8_t linkId,
-                          std::string context,
+    virtual void Transmit(Ptr<WifiMac> mac,
+                          uint8_t phyId,
                           WifiConstPsduMap psduMap,
                           WifiTxVector txVector,
                           double txPowerW);
@@ -193,6 +184,27 @@
                                            std::size_t count,
                                            std::size_t pktSize) const;
 
+    /**
+     * Check whether QoS data unicast transmissions addressed to the given destination on the
+     * given link are blocked or unblocked for the given reason on the given device.
+     *
+     * \param mac the MAC of the given device
+     * \param dest the MAC address of the given destination
+     * \param linkId the ID of the given link
+     * \param reason the reason for blocking transmissions to test
+     * \param blocked whether transmissions are blocked for the given reason
+     * \param description text indicating when this check is performed
+     * \param testUnblockedForOtherReasons whether to test if transmissions are unblocked for
+     *                                     all the reasons other than the one provided
+     */
+    void CheckBlockedLink(Ptr<WifiMac> mac,
+                          Mac48Address dest,
+                          uint8_t linkId,
+                          WifiQueueBlockedReason reason,
+                          bool blocked,
+                          std::string description,
+                          bool testUnblockedForOtherReasons = true);
+
     void DoSetup() override;
 
     /// Information about transmitted frames
@@ -202,8 +214,10 @@
         WifiConstPsduMap psduMap; ///< transmitted PSDU map
         WifiTxVector txVector;    ///< TXVECTOR
         uint8_t linkId;           ///< link ID
+        uint8_t phyId;            ///< ID of the transmitting PHY
     };
 
+    uint8_t m_mainPhyId{0};                   //!< ID of the main PHY
     std::set<uint8_t> m_linksToEnableEmlsrOn; /**< IDs of the links on which EMLSR mode has to
                                                    be enabled */
     std::size_t m_nEmlsrStations{1};          ///< number of stations to create that activate EMLSR
@@ -250,21 +264,24 @@
 }
 
 void
-EmlsrOperationsTestBase::Transmit(uint8_t linkId,
-                                  std::string context,
+EmlsrOperationsTestBase::Transmit(Ptr<WifiMac> mac,
+                                  uint8_t phyId,
                                   WifiConstPsduMap psduMap,
                                   WifiTxVector txVector,
                                   double txPowerW)
 {
-    m_txPsdus.push_back({Simulator::Now(), psduMap, txVector, linkId});
+    auto linkId = mac->GetLinkForPhy(phyId);
+    NS_TEST_ASSERT_MSG_EQ(linkId.has_value(), true, "No link found for PHY ID " << +phyId);
+    m_txPsdus.push_back({Simulator::Now(), psduMap, txVector, *linkId, phyId});
+
     auto txDuration =
-        WifiPhy::CalculateTxDuration(psduMap, txVector, m_apMac->GetWifiPhy(linkId)->GetPhyBand());
+        WifiPhy::CalculateTxDuration(psduMap, txVector, mac->GetWifiPhy(*linkId)->GetPhyBand());
 
     for (const auto& [aid, psdu] : psduMap)
     {
         std::stringstream ss;
-        ss << std::setprecision(10) << "PSDU #" << m_txPsdus.size() << " Link ID " << +linkId << " "
-           << psdu->GetHeader(0).GetTypeString();
+        ss << std::setprecision(10) << "PSDU #" << m_txPsdus.size() << " Link ID "
+           << +linkId.value() << " Phy ID " << +phyId << " " << psdu->GetHeader(0).GetTypeString();
         if (psdu->GetHeader(0).IsAction())
         {
             ss << " ";
@@ -341,7 +358,9 @@
                 BooleanValue(false));
     mac.SetEmlsrManager("ns3::DefaultEmlsrManager",
                         "EmlsrLinkSet",
-                        AttributeContainerValue<UintegerValue>(m_linksToEnableEmlsrOn));
+                        AttributeContainerValue<UintegerValue>(m_linksToEnableEmlsrOn),
+                        "MainPhyId",
+                        UintegerValue(m_mainPhyId));
 
     NetDeviceContainer staDevices = wifi.Install(phyHelper, mac, wifiStaNodes);
 
@@ -375,11 +394,22 @@
     }
 
     // Trace PSDUs passed to the PHY on AP MLD and non-AP MLDs
-    for (uint8_t linkId = 0; linkId < m_apMac->GetNLinks(); linkId++)
+    for (uint8_t phyId = 0; phyId < m_apMac->GetDevice()->GetNPhys(); phyId++)
+    {
+        Config::ConnectWithoutContext(
+            "/NodeList/0/DeviceList/*/$ns3::WifiNetDevice/Phys/" + std::to_string(phyId) +
+                "/PhyTxPsduBegin",
+            MakeCallback(&EmlsrOperationsTestBase::Transmit, this).Bind(m_apMac, phyId));
+    }
+    for (std::size_t i = 0; i < m_nEmlsrStations + m_nNonEmlsrStations; i++)
     {
-        Config::Connect("/NodeList/*/DeviceList/*/$ns3::WifiNetDevice/Phys/" +
-                            std::to_string(linkId) + "/PhyTxPsduBegin",
-                        MakeCallback(&EmlsrOperationsTestBase::Transmit, this).Bind(linkId));
+        for (uint8_t phyId = 0; phyId < m_staMacs[i]->GetDevice()->GetNPhys(); phyId++)
+        {
+            Config::ConnectWithoutContext(
+                "/NodeList/" + std::to_string(i + 1) + "/DeviceList/*/$ns3::WifiNetDevice/Phys/" +
+                    std::to_string(phyId) + "/PhyTxPsduBegin",
+                MakeCallback(&EmlsrOperationsTestBase::Transmit, this).Bind(m_staMacs[i], phyId));
+        }
     }
 
     // Uncomment the lines below to write PCAP files
@@ -509,6 +539,50 @@
     });
 }
 
+void
+EmlsrOperationsTestBase::CheckBlockedLink(Ptr<WifiMac> mac,
+                                          Mac48Address dest,
+                                          uint8_t linkId,
+                                          WifiQueueBlockedReason reason,
+                                          bool blocked,
+                                          std::string description,
+                                          bool testUnblockedForOtherReasons)
+{
+    WifiContainerQueueId queueId(WIFI_QOSDATA_QUEUE, WIFI_UNICAST, dest, 0);
+    auto mask = mac->GetMacQueueScheduler()->GetQueueLinkMask(AC_BE, queueId, linkId);
+    NS_TEST_EXPECT_MSG_EQ(mask.has_value(),
+                          true,
+                          description << ": Expected to find a mask for EMLSR link " << +linkId);
+    if (blocked)
+    {
+        NS_TEST_EXPECT_MSG_EQ(mask->test(static_cast<std::size_t>(reason)),
+                              true,
+                              description << ": Expected EMLSR link " << +linkId
+                                          << " to be blocked for reason " << reason);
+        if (testUnblockedForOtherReasons)
+        {
+            NS_TEST_EXPECT_MSG_EQ(mask->count(),
+                                  1,
+                                  description << ": Expected EMLSR link " << +linkId
+                                              << " to be blocked for one reason only");
+        }
+    }
+    else if (testUnblockedForOtherReasons)
+    {
+        NS_TEST_EXPECT_MSG_EQ(mask->none(),
+                              true,
+                              description << ": Expected EMLSR link " << +linkId
+                                          << " to be unblocked");
+    }
+    else
+    {
+        NS_TEST_EXPECT_MSG_EQ(mask->test(static_cast<std::size_t>(reason)),
+                              false,
+                              description << ": Expected EMLSR link " << +linkId
+                                          << " to be unblocked for reason " << reason);
+    }
+}
+
 /**
  * \ingroup wifi-test
  * \ingroup tests
@@ -531,7 +605,7 @@
  *   timeout expires and when an EML Notification response is received from the AP MLD (thus,
  *   the correct EMLSR link set is stored after whichever of the two events occur first)
  */
-class EmlNotificationExchangeTest : public EmlsrOperationsTestBase
+class EmlOmnExchangeTest : public EmlsrOperationsTestBase
 {
   public:
     /**
@@ -540,15 +614,14 @@
      * \param linksToEnableEmlsrOn IDs of links on which EMLSR mode should be enabled
      * \param transitionTimeout the Transition Timeout advertised by the AP MLD
      */
-    EmlNotificationExchangeTest(const std::set<uint8_t>& linksToEnableEmlsrOn,
-                                Time transitionTimeout);
-    ~EmlNotificationExchangeTest() override = default;
+    EmlOmnExchangeTest(const std::set<uint8_t>& linksToEnableEmlsrOn, Time transitionTimeout);
+    ~EmlOmnExchangeTest() override = default;
 
   protected:
     void DoSetup() override;
     void DoRun() override;
-    void Transmit(uint8_t linkId,
-                  std::string context,
+    void Transmit(Ptr<WifiMac> mac,
+                  uint8_t phyId,
                   WifiConstPsduMap psduMap,
                   WifiTxVector txVector,
                   double txPowerW) override;
@@ -605,7 +678,6 @@
     void CheckEmlsrLinks();
 
   private:
-    std::optional<uint8_t> m_assocLinkId;      //!< ID of the link used to establish association
     std::size_t m_checkEmlsrLinksCount;        /**< counter for the number of times CheckEmlsrLinks
                                                     is called (should be two: when the transition
                                                     timeout expires and when the EML Notification
@@ -617,9 +689,8 @@
     std::list<uint64_t> m_uidList;             ///< list of UIDs of packets to corrupt
 };
 
-EmlNotificationExchangeTest::EmlNotificationExchangeTest(
-    const std::set<uint8_t>& linksToEnableEmlsrOn,
-    Time transitionTimeout)
+EmlOmnExchangeTest::EmlOmnExchangeTest(const std::set<uint8_t>& linksToEnableEmlsrOn,
+                                       Time transitionTimeout)
     : EmlsrOperationsTestBase("Check EML Notification exchange"),
       m_checkEmlsrLinksCount(0),
       m_emlNotificationDroppedCount(0)
@@ -632,7 +703,7 @@
 }
 
 void
-EmlNotificationExchangeTest::DoSetup()
+EmlOmnExchangeTest::DoSetup()
 {
     EmlsrOperationsTestBase::DoSetup();
 
@@ -642,27 +713,28 @@
         m_apMac->GetWifiPhy(linkId)->SetPostReceptionErrorModel(m_errorModel);
     }
 
-    m_staMacs[0]->TraceConnectWithoutContext(
-        "AckedMpdu",
-        MakeCallback(&EmlNotificationExchangeTest::TxOk, this));
-    m_staMacs[0]->TraceConnectWithoutContext(
-        "DroppedMpdu",
-        MakeCallback(&EmlNotificationExchangeTest::TxDropped, this));
+    m_staMacs[0]->TraceConnectWithoutContext("AckedMpdu",
+                                             MakeCallback(&EmlOmnExchangeTest::TxOk, this));
+    m_staMacs[0]->TraceConnectWithoutContext("DroppedMpdu",
+                                             MakeCallback(&EmlOmnExchangeTest::TxDropped, this));
 }
 
 void
-EmlNotificationExchangeTest::Transmit(uint8_t linkId,
-                                      std::string context,
-                                      WifiConstPsduMap psduMap,
-                                      WifiTxVector txVector,
-                                      double txPowerW)
+EmlOmnExchangeTest::Transmit(Ptr<WifiMac> mac,
+                             uint8_t phyId,
+                             WifiConstPsduMap psduMap,
+                             WifiTxVector txVector,
+                             double txPowerW)
 {
+    EmlsrOperationsTestBase::Transmit(mac, phyId, psduMap, txVector, txPowerW);
+    auto linkId = m_txPsdus.back().linkId;
+
     auto psdu = psduMap.begin()->second;
 
     switch (psdu->GetHeader(0).GetType())
     {
     case WIFI_MAC_MGT_ASSOCIATION_REQUEST:
-        m_assocLinkId = linkId;
+        NS_TEST_EXPECT_MSG_EQ(+linkId, +m_mainPhyId, "AssocReq not sent by the main PHY");
         CheckEmlCapabilitiesInAssocReq(*psdu->begin(), txVector, linkId);
         break;
 
@@ -690,14 +762,12 @@
 
     default:;
     }
-
-    EmlsrOperationsTestBase::Transmit(linkId, context, psduMap, txVector, txPowerW);
 }
 
 void
-EmlNotificationExchangeTest::CheckEmlCapabilitiesInAssocReq(Ptr<const WifiMpdu> mpdu,
-                                                            const WifiTxVector& txVector,
-                                                            uint8_t linkId)
+EmlOmnExchangeTest::CheckEmlCapabilitiesInAssocReq(Ptr<const WifiMpdu> mpdu,
+                                                   const WifiTxVector& txVector,
+                                                   uint8_t linkId)
 {
     MgtAssocRequestHeader frame;
     mpdu->GetPacket()->PeekHeader(frame);
@@ -720,9 +790,9 @@
 }
 
 void
-EmlNotificationExchangeTest::CheckEmlCapabilitiesInAssocResp(Ptr<const WifiMpdu> mpdu,
-                                                             const WifiTxVector& txVector,
-                                                             uint8_t linkId)
+EmlOmnExchangeTest::CheckEmlCapabilitiesInAssocResp(Ptr<const WifiMpdu> mpdu,
+                                                    const WifiTxVector& txVector,
+                                                    uint8_t linkId)
 {
     bool sentToEmlsrClient =
         (m_staMacs[0]->GetLinkIdByAddress(mpdu->GetHeader().GetAddr1()) == linkId);
@@ -752,11 +822,11 @@
 }
 
 void
-EmlNotificationExchangeTest::CheckEmlNotification(Ptr<const WifiPsdu> psdu,
-                                                  const WifiTxVector& txVector,
-                                                  uint8_t linkId)
+EmlOmnExchangeTest::CheckEmlNotification(Ptr<const WifiPsdu> psdu,
+                                         const WifiTxVector& txVector,
+                                         uint8_t linkId)
 {
-    MgtEmlOperatingModeNotification frame;
+    MgtEmlOmn frame;
     auto mpdu = *psdu->begin();
     auto pkt = mpdu->GetPacket()->Copy();
     WifiActionHeader::Remove(pkt);
@@ -806,20 +876,17 @@
                                                   txVector,
                                                   m_staMacs[0]->GetWifiPhy(linkId)->GetPhyBand()) +
                      MicroSeconds(1); // to account for propagation delay
-        Simulator::Schedule(delay, &EmlNotificationExchangeTest::CheckEmlsrLinks, this);
+        Simulator::Schedule(delay, &EmlOmnExchangeTest::CheckEmlsrLinks, this);
     }
 
-    NS_TEST_ASSERT_MSG_EQ(m_assocLinkId.has_value(),
-                          true,
-                          "No link ID indicating the link on which association was performed");
-    NS_TEST_EXPECT_MSG_EQ(+m_assocLinkId.value(),
+    NS_TEST_EXPECT_MSG_EQ(+m_mainPhyId,
                           +linkId,
                           "EML Notification received on unexpected link (frame sent by non-AP MLD: "
                               << std::boolalpha << sentbyNonApMld << ")");
 }
 
 void
-EmlNotificationExchangeTest::TxOk(Ptr<const WifiMpdu> mpdu)
+EmlOmnExchangeTest::TxOk(Ptr<const WifiMpdu> mpdu)
 {
     const auto& hdr = mpdu->GetHeader();
 
@@ -833,14 +900,14 @@
             // the EML Operating Mode Notification frame that the non-AP MLD sent has been
             // acknowledged; after the transition timeout, the EMLSR links have been set
             Simulator::Schedule(m_transitionTimeout + NanoSeconds(1),
-                                &EmlNotificationExchangeTest::CheckEmlsrLinks,
+                                &EmlOmnExchangeTest::CheckEmlsrLinks,
                                 this);
         }
     }
 }
 
 void
-EmlNotificationExchangeTest::TxDropped(WifiMacDropReason reason, Ptr<const WifiMpdu> mpdu)
+EmlOmnExchangeTest::TxDropped(WifiMacDropReason reason, Ptr<const WifiMpdu> mpdu)
 {
     const auto& hdr = mpdu->GetHeader();
 
@@ -859,7 +926,7 @@
 }
 
 void
-EmlNotificationExchangeTest::CheckEmlsrLinks()
+EmlOmnExchangeTest::CheckEmlsrLinks()
 {
     m_checkEmlsrLinksCount++;
 
@@ -877,7 +944,7 @@
 }
 
 void
-EmlNotificationExchangeTest::DoRun()
+EmlOmnExchangeTest::DoRun()
 {
     Simulator::Stop(m_duration);
     Simulator::Run();
@@ -970,8 +1037,8 @@
   protected:
     void DoSetup() override;
     void DoRun() override;
-    void Transmit(uint8_t linkId,
-                  std::string context,
+    void Transmit(Ptr<WifiMac> mac,
+                  uint8_t phyId,
                   WifiConstPsduMap psduMap,
                   WifiTxVector txVector,
                   double txPowerW) override;
@@ -1031,11 +1098,11 @@
      *
      * \param psduMap the PSDU carrying BlockAck frames
      * \param txVector the TXVECTOR used to send the PPDU
-     * \param linkId the ID of the given link
+     * \param phyId the ID of the PHY transmitting the PSDU(s)
      */
     void CheckBlockAck(const WifiConstPsduMap& psduMap,
                        const WifiTxVector& txVector,
-                       uint8_t linkId);
+                       uint8_t phyId);
 
   private:
     void StartTraffic() override;
@@ -1046,14 +1113,11 @@
     void EnableEmlsrMode();
 
     std::set<uint8_t> m_emlsrLinks; /**< IDs of the links on which EMLSR mode has to be enabled */
-    std::vector<std::optional<uint8_t>>
-        m_assocLinkId; /**< ID of the link used to establish association (vector index is the node
-                          ID) */
-    Time m_emlsrEnabledTime;      //!< when EMLSR mode has been enabled on all EMLSR clients
-    const Time m_fe2to3delay;     /**< time interval between 2nd and 3rd frame exchange sequences
-                                       after the enablement of EMLSR mode */
-    std::size_t m_countQoSframes; //!< counter for QoS frames (transition delay test)
-    std::size_t m_countBlockAck;  //!< counter for BlockAck frames (transition delay test)
+    Time m_emlsrEnabledTime;        //!< when EMLSR mode has been enabled on all EMLSR clients
+    const Time m_fe2to3delay;       /**< time interval between 2nd and 3rd frame exchange sequences
+                                         after the enablement of EMLSR mode */
+    std::size_t m_countQoSframes;   //!< counter for QoS frames (transition delay test)
+    std::size_t m_countBlockAck;    //!< counter for BlockAck frames (transition delay test)
     Ptr<ListErrorModel> m_errorModel; ///< error rate model to corrupt BlockAck at AP MLD
 };
 
@@ -1066,7 +1130,6 @@
     : EmlsrOperationsTestBase("Check EML DL TXOP transmissions (" + std::to_string(nEmlsrStations) +
                               "," + std::to_string(nNonEmlsrStations) + ")"),
       m_emlsrLinks(linksToEnableEmlsrOn),
-      m_assocLinkId(1 + nEmlsrStations + nNonEmlsrStations, std::nullopt),
       m_emlsrEnabledTime(0),
       m_fe2to3delay(MilliSeconds(20)),
       m_countQoSframes(0),
@@ -1075,6 +1138,7 @@
     m_nEmlsrStations = nEmlsrStations;
     m_nNonEmlsrStations = nNonEmlsrStations;
     m_linksToEnableEmlsrOn = {}; // do not enable EMLSR right after association
+    m_mainPhyId = 1;
     m_paddingDelay = paddingDelay;
     m_transitionDelay = transitionDelay;
     m_transitionTimeout = transitionTimeout;
@@ -1086,26 +1150,29 @@
 }
 
 void
-EmlsrDlTxopTest::Transmit(uint8_t linkId,
-                          std::string context,
+EmlsrDlTxopTest::Transmit(Ptr<WifiMac> mac,
+                          uint8_t phyId,
                           WifiConstPsduMap psduMap,
                           WifiTxVector txVector,
                           double txPowerW)
 {
+    EmlsrOperationsTestBase::Transmit(mac, phyId, psduMap, txVector, txPowerW);
+    auto linkId = m_txPsdus.back().linkId;
+
     auto psdu = psduMap.begin()->second;
-    auto nodeId = ContextToNodeId(context);
+    auto nodeId = mac->GetDevice()->GetNode()->GetId();
 
     switch (psdu->GetHeader(0).GetType())
     {
     case WIFI_MAC_MGT_ASSOCIATION_REQUEST:
         NS_ASSERT_MSG(nodeId > 0, "APs do not send AssocReq frames");
-        m_assocLinkId.at(nodeId) = linkId;
         if (nodeId <= m_nEmlsrStations)
         {
+            NS_TEST_EXPECT_MSG_EQ(+linkId, +m_mainPhyId, "AssocReq not sent by the main PHY");
             // this AssocReq is being sent by an EMLSR client. The other EMLSR links should be
             // in powersave mode after association; we let the non-EMLSR links transition to
             // active mode (by sending data null frames) after association
-            for (uint8_t id = 0; id < m_staMacs.at(nodeId - 1)->GetNLinks(); id++)
+            for (const auto id : m_staMacs.at(nodeId - 1)->GetLinkIds())
             {
                 if (id != linkId && m_emlsrLinks.count(id) == 1)
                 {
@@ -1141,13 +1208,11 @@
         break;
 
     case WIFI_MAC_CTL_BACKRESP:
-        CheckBlockAck(psduMap, txVector, linkId);
+        CheckBlockAck(psduMap, txVector, phyId);
         break;
 
     default:;
     }
-
-    EmlsrOperationsTestBase::Transmit(linkId, context, psduMap, txVector, txPowerW);
 }
 
 void
@@ -1222,7 +1287,7 @@
 
         Simulator::Schedule(m_fe2to3delay + MilliSeconds(5 * (m_nEmlsrStations + 1)), [=]() {
             m_apMac->GetDevice()->GetNode()->AddApplication(
-                GetApplication(DOWNLINK, id, 8 / m_nEmlsrStations, 450));
+                GetApplication(DOWNLINK, id, 8 / m_nEmlsrStations, 650));
         });
     }
 }
@@ -1358,15 +1423,13 @@
         auto setupLinks = m_staMacs[i]->GetSetupLinkIds();
         if (i < m_nEmlsrStations &&
             std::none_of(setupLinks.begin(), setupLinks.end(), [&](auto&& linkId) {
-                return linkId != *m_assocLinkId[i + 1] && m_emlsrLinks.count(linkId) == 0;
+                return linkId != m_mainPhyId && m_emlsrLinks.count(linkId) == 0;
             }))
         {
             NS_TEST_EXPECT_MSG_EQ(linkIds.size(),
                                   1,
                                   "Expected both A-MPDUs to be sent on the same link");
-            NS_TEST_EXPECT_MSG_EQ(*linkIds.begin(),
-                                  *m_assocLinkId[i + 1],
-                                  "A-MPDUs sent on incorrect link");
+            NS_TEST_EXPECT_MSG_EQ(*linkIds.begin(), +m_mainPhyId, "A-MPDUs sent on incorrect link");
             NS_TEST_EXPECT_MSG_LT(firstAmpduTxEnd,
                                   secondAmpduTxStart,
                                   "A-MPDUs are not sent one after another");
@@ -1638,15 +1701,15 @@
      *                   │CTS│       │BA│       │BA│
      *                   ├───┤       ├──┤       └──┘
      *                   │CTS│       │BA│
-     *                   └───┘       └──┘                      A switches to listening
-     *                                                         after timeout + transition delay
-     *                                                         │
-     *                                     ┌───┐     ┌─────┐   │       ┌───┐
-     *                                     │MU │     │QoS x│   │       │MU │     ┌───┐
-     *  [link 1]                           │RTS│     │ to A│   │       │RTS│     │BAR│
-     *  ───────────────────────────────────┴───┴┬───┬┴─────┴┬──┬───────┴───┴┬───┬┴───┴┬──┬─
-     *                                          │CTS│       │BA│            │CTS│     │BA│
-     *                                          └───┘       └──x            └───┘     └──┘
+     *                   └───┘       └──┘  AP continues the TXOP despite   A switches to listening
+     *                                     the failure, but sends an ICF    after transition delay
+     *                                                                │                       │
+     *                                            ┌───┐     ┌─────┐   │┌───┐              ┌───┐
+     *                                            │MU │     │QoS x│   ││MU │     ┌───┐    │CF-│
+     *  [link 1]                                  │RTS│     │ to A│   ││RTS│     │BAR│    │End│
+     *  ──────────────────────────────────────────┴───┴┬───┬┴─────┴┬──┬┴───┴┬───┬┴───┴┬──┬┴───┴─
+     *                                                 │CTS│       │BA│     │CTS│     │BA│
+     *                                                 └───┘       └──x     └───┘     └──┘
      */
     if (m_nEmlsrStations == 2 && m_apMac->GetNLinks() == m_emlsrLinks.size())
     {
@@ -1766,11 +1829,16 @@
                                                                            phy->GetPhyBand());
         auto timeout = phy->GetSifs() + phy->GetSlot() + MicroSeconds(20);
 
-        // the fourth frame exchange starts a SIFS after the previous one
+        // the fourth frame exchange starts a SIFS after the previous one because the AP can
+        // continue the TXOP despite it does not receive the BlockAck (the AP received the
+        // PHY-RXSTART.indication and the frame exchange involves an EMLSR client)
         NS_TEST_EXPECT_MSG_GT_OR_EQ(fourthExchangeIt->front()->startTx,
-                                    bAckRespTxEnd + timeout +
-                                        m_transitionDelay.at(thirdExchangeStaId),
-                                    "Transmission started before transition delay");
+                                    bAckRespTxEnd + phy->GetSifs(),
+                                    "Transmission started less than a SIFS after BlockAck");
+        NS_TEST_EXPECT_MSG_LT(fourthExchangeIt->front()->startTx,
+                              bAckRespTxEnd + phy->GetSifs() +
+                                  MicroSeconds(1) /* propagation delay upper bound */,
+                              "Transmission started too much time after BlockAck");
 
         auto bAckReqIt = std::next(fourthExchangeIt->front(), 2);
         NS_TEST_EXPECT_MSG_EQ(bAckReqIt->psduMap.cbegin()->second->GetHeader(0).IsBlockAckReq(),
@@ -1846,31 +1914,34 @@
     // (ICF protects the EML Notification response) and two frame exchanges with data frames
     for (std::size_t i = 0; i < m_nEmlsrStations; i++)
     {
-        // if the EML Notification frame disabling EMLSR mode is sent on an EMLSR link, it
-        // is protected by an ICF; otherwise, it is not protected. Given that the default
-        // EMLSR Manager sends EML Notification frames on the link used to establish association,
-        // ICF is sent to protect the EML Notification frame if the link used to establish
-        // association is an EMLSR link
-        if (m_emlsrLinks.count(*m_assocLinkId.at(i + 1)) == 1)
-        {
-            auto firstExchangeIt = frameExchanges.at(i).begin();
+        // the default EMLSR Manager requests to send EML Notification frames on the link where
+        // the main PHY is operating, hence this link is an EMLSR link and the EML Notification
+        // frame is protected by an ICF
+        auto exchangeIt = frameExchanges.at(i).cbegin();
 
-            NS_TEST_EXPECT_MSG_EQ(IsTrigger(firstExchangeIt->front()->psduMap),
-                                  true,
-                                  "Expected an MU-RTS TF as ICF of first frame exchange sequence");
-            NS_TEST_EXPECT_MSG_EQ(firstExchangeIt->size(),
-                                  1,
-                                  "Expected no data frame in the first frame exchange sequence");
+        auto linkIdOpt = m_staMacs[i]->GetLinkForPhy(m_mainPhyId);
+        NS_TEST_ASSERT_MSG_EQ(linkIdOpt.has_value(),
+                              true,
+                              "Didn't find a link on which the main PHY is operating");
 
-            frameExchanges.at(i).pop_front();
-        }
+        NS_TEST_EXPECT_MSG_EQ(IsTrigger(exchangeIt->front()->psduMap),
+                              true,
+                              "Expected an MU-RTS TF as ICF of first frame exchange sequence");
+        NS_TEST_EXPECT_MSG_EQ(+exchangeIt->front()->linkId,
+                              +linkIdOpt.value(),
+                              "ICF was not sent on the expected link");
+        NS_TEST_EXPECT_MSG_EQ(exchangeIt->size(),
+                              1,
+                              "Expected no data frame in the first frame exchange sequence");
+
+        frameExchanges.at(i).pop_front();
 
         NS_TEST_EXPECT_MSG_GT_OR_EQ(frameExchanges.at(i).size(),
                                     2,
                                     "Expected at least 2 frame exchange sequences "
                                         << "involving EMLSR client " << i);
 
-        auto firstExchangeIt = frameExchanges.at(i).begin();
+        auto firstExchangeIt = frameExchanges.at(i).cbegin();
         auto secondExchangeIt = std::next(firstExchangeIt);
 
         const auto firstAmpduTxEnd =
@@ -1897,20 +1968,19 @@
                               1,
                               "Expected one frame only in the second frame exchange sequence");
 
-        if (m_staMacs[i]->GetNLinks() == m_emlsrLinks.size() ||
-            m_emlsrLinks.count(*m_assocLinkId.at(i + 1)) == 0)
+        if (m_staMacs[i]->GetNLinks() == m_emlsrLinks.size())
         {
-            // all links are EMLSR links or the non-EMLSR link is the link used for association:
-            // the two QoS data frames are sent one after another on the link used for association
+            // all links are EMLSR links: the two QoS data frames are sent one after another on
+            // the link used for sending EML OMN
             NS_TEST_EXPECT_MSG_EQ(
                 +firstExchangeIt->front()->linkId,
-                +(*m_assocLinkId.at(i + 1)),
-                "First frame exchange expected to occur on link used for association");
+                +linkIdOpt.value(),
+                "First frame exchange expected to occur on link used to send EML OMN");
 
             NS_TEST_EXPECT_MSG_EQ(
                 +secondExchangeIt->front()->linkId,
-                +(*m_assocLinkId.at(i + 1)),
-                "Second frame exchange expected to occur on link used for association");
+                +linkIdOpt.value(),
+                "Second frame exchange expected to occur on link used to send EML OMN");
 
             NS_TEST_EXPECT_MSG_LT(firstAmpduTxEnd,
                                   secondAmpduTxStart,
